package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LineCointonetwork struct {
	service.Service
}

// GetPage 获取LineCointonetwork列表
func (e *LineCointonetwork) GetPage(c *dto.LineCointonetworkGetPageReq, p *actions.DataPermission, list *[]models.LineCointonetwork, count *int64) error {
	var err error
	var data models.LineCointonetwork

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineCointonetworkService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineCointonetwork对象
func (e *LineCointonetwork) Get(d *dto.LineCointonetworkGetReq, p *actions.DataPermission, model *models.LineCointonetwork) error {
	var data models.LineCointonetwork

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineCointonetwork error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineCointonetwork对象
func (e *LineCointonetwork) Insert(c *dto.LineCointonetworkInsertReq) error {
    var err error
    var data models.LineCointonetwork
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineCointonetworkService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LineCointonetwork对象
func (e *LineCointonetwork) Update(c *dto.LineCointonetworkUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LineCointonetwork{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LineCointonetworkService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LineCointonetwork
func (e *LineCointonetwork) Remove(d *dto.LineCointonetworkDeleteReq, p *actions.DataPermission) error {
	var data models.LineCointonetwork

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLineCointonetwork error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
